; TIP1070.LSP: BPLODE.LSP   Explode Blocks   (c)1995, Jon L. McFarland

(defun C:BPLODE ()

   (setq CMD (getvar "cmdecho"))
   (setvar "cmdecho" 0)
   (setq CNTR1 0)
   (setq CNTR2 0)
   (setq CNTR3 0)
   (graphscr)

   (initget "Crossing Window")
   (setq SCH (getkword "Entity selection by Crossing or Window? <W>"))

   (initget 33)
   (setq SP (getpoint "Select first point"))

   (princ "\nSelect second point")
   (initget 33)
   (setq SP1 (getcorner SP))

   (while (and CNTR1 (/= CNTR3 SS1L)) ;while loop 1
      (setq CNTR1 0)
      (setq CNTR3 0)
      (if (= SCH "Crossing")
         (setq SS1 (ssget "c" SP SP1 '((0 . "insert"))))
         (setq SS1 (ssget "w" SP SP1 '((0 . "insert"))))
      )

      (if (/= SS1 nil)
         (progn
            (setq SS1L (sslength SS1))
            (setq CNTR2 (+ CNTR2 SS1L))
            (while (< CNTR1 SS1L)       ;while loop 2
               (setq CK1 (entget (ssname SS1 CNTR1)))
               (setq CK2 (cdr (assoc 41 CK1)))
               (setq CK3 (cdr (assoc 42 CK1)))
               (setq CK4 (substr (cdr (assoc 2 CK1))1 1))
               (if (and (= CK2 CK3) (/= CK4 "*"))
                  (command "explode" (cdr (car CK1)))
                  (progn
                     (setq CNTR2 (1- CNTR2))
                     (setq CNTR3 (1+ CNTR3))
                  )
               )
               (setq CNTR1 (1+ CNTR1))
            )                           ;close while loop 2
         )
         (setq CNTR1 nil)
      )
   )   ;close while loop 1

   (prompt (strcat "\n" (itoa CNTR2) " blocks exploded."))
   (prompt (strcat
   "\n" (itoa CNTR3) " was/were unevenly scaled or a hatch pattern."))

   (setvar "cmdecho" CMD)
   (prin1)
) ;end bplode.lsp
