; TIP1073.LSP: DFSRO.LSP   Dimension an Opening   (c)1995, Keith Bigg

;; Layer Dim must exist
(defun C:DFSRO (/ A B C D E ELIST ELIST_R LLC URC ULCX ULCY ULC)
   (graphscr)
   (setvar "CMDECHO" 0)
   (setvar "OSMODE" 32)
   (setvar "DIMALT" 0)

   (setq dim_add 0.5) ;;set dimension to add here
   (setq dim_hor_ofst "@0.0,12")  ;; set horizontal dim offset here
   (setq dim_ver_ofst "@-12,0.0") ;; set vertical dim offset here

   (command "dim" "dimaso" "off" "dimlim" "1" "dimpost" " F.S." "dimtp" dim_add "dimtm" "0" "exit")
   (command "layer" "s" "dim" "")
   (setq LLC (getpoint "\nLower left frame: "))
   (setq URC (getpoint "\nUpper right frame: "))
   (setq ULC (list (car LLC) (cadr URC)))
   (command "dim" "hor" ULC URC dim_hor_ofst "" "exit") 
   (setq ELIST (entget (entlast)))
   (setq A (assoc 1 elist))
   (setq B (cdr A))
   (setq C (strlen B))
   (setq D (substr B  1  (- C  5)))
   (setq E (strcat D  " R.O."))
   (setq ELIST_R (subst  (cons 1 E)  (assoc 1 ELIST)  ELIST))
   (entmod ELIST_R)
   (setvar "OSMODE" 32)
   (command "dim" "ver" LLC ULC dim_ver_ofst "" "EXIT")
   (setq ELIST (entget (entlast)))
   (setq A (assoc 1 elist))
   (setq B (cdr A))
   (setq C (strlen B))
   (setq D (substr B  1  (- C  5)))
   (setq E (strcat D  " R.O."))
   (setq ELIST_R (subst  (cons 1 E)  (assoc 1 ELIST)  ELIST))
   (entmod ELIST_R)
   (setvar "OSMODE" 0)
   (setvar "CMDECHO" 1)
   (princ)
); end dsfro.lsp
