; TIP1077.LSP: MLAC.LSP   Delete Small Entities Before Plotting
;                          (c)1995, Jon L. McFarland

(defun C:MLAC ()
   (initget "Lines Arcs Circles ALL")
   (setq SEL (getkword "Delete Lines, Arcs or Circles  <ALL>? "))

   (if (= SEL nil)
      (setq SEL "ALL")
   )

   (if (or (= SEL "Lines")(= SEL "ALL"))
      (progn
         (initget 7)
         (setq SML (getreal " Minimum line length: "))
         (setq SSA (ssget '((0 . "LINE"))))
         (if (/= SSA nil)
            (progn
               (setq SSAL (sslength SSA))
               (setq CNTR1 0)
               (setq CNTR2 0)

               (while (< CNTR1 SSAL)
                  (setq LNM (ssname SSA CNTR1))
                  (setq LSTRT (cdr (assoc 10 (entget LNM))))
                  (setq LEND (cdr (assoc 11 (entget LNM))))
                  (setq LLEN (distance LSTRT LEND))
                  (if (< LLEN SML)
                     (progn
                        (entdel LNM)
                        (setq CNTR2 (1+ CNTR2))
                     )
                  )
                  (setq CNTR1 (1+ CNTR1))
               )

               (princ (strcat (itoa CNTR2) " lines deleted"))
               (terpri)
            )
            (progn
               (princ "No lines selected")
               (terpri)
            )
         )
      )
   )

   (if (or (= SEL "Arcs")(= SEL "ALL"))
      (progn
         (initget 7)
         (setq SMA (getreal " Minimum arc radius: "))
         (setq SSB (ssget '((0 . "ARC"))))
         (if (/= SSB nil)
            (progn
               (setq SSBL (sslength SSB))
               (setq CNTR1 0)
               (setq CNTR2 0)
               (while (< CNTR1 SSBL)
                  (setq ANM (ssname SSB CNTR1))
                  (setq ARCR (cdr (assoc 40 (entget ANM))))
                  (if (< ARCR SMA)
                     (progn
                        (entdel ANM)
                        (setq CNTR2 (1+ CNTR2))
                     )
                  )
                  (setq CNTR1 (1+ CNTR1))
               )
               (princ (strcat (itoa CNTR2) " arcs deleted"))
               (terpri)
            )
            (progn
               (princ "No arcs selected")
               (terpri)
            )
         )
      )
   )
   (if (or (= SEL "Circles")(= SEL "ALL"))
      (progn
         (initget 7)
         (setq SMC (getreal " Minimum circle radius: "))
         (setq SSC (ssget '((0 . "CIRCLE"))))
         (if (/= SSC nil)
            (progn
               (setq SSCL (sslength SSC))
               (setq CNTR1 0)
               (setq CNTR2 0)
               (while (< CNTR1 SSCL)
                  (setq CNM (ssname SSC CNTR1))
                  (setq CCR (cdr (assoc 40 (entget CNM))))
                  (if (< CCR SMC)
                     (progn
                        (entdel CNM)
                        (setq CNTR2 (1+ CNTR2))
                     )
                  )
                  (setq CNTR1 (1+ CNTR1))
               )
               (princ (strcat (itoa CNTR2) " circles  deleted"))
               (terpri)
            )
            (progn
               (princ "No circles selected")
               (terpri)
            )
         )
      )
   )
   (prin1)
); end mlac.lsp

