; TIP1079.LSP: TXT.LSP   Text Spacing   (c)1995, Basil L. Lemon

; Allows user to define the spacing and direction 
; for multiple lines of text.
; Must be physical points.
; Expects at least two lines of text.

(defun *error* (MSG)
   (setvar "CMDECHO" 1)
   (princ)
)
(defun C:TXT()
   (setvar "CMDECHO" 0)
   (prompt "\nDefine two points for text spacing:")
   (setq P1 (getpoint "\nFirst Point:"))
   (command "point" P1 "erase" "l" "")
   (setq P2 (Getpoint "\nSecond Point:"))
   (setq DIST (distance P1 P2))
   (setq JUST (getstring  "\nJustification<bl>:")
      JUST(strcase JUST)
   )
   (if (= JUST "") (setq JUST "bl"))
   (setq S (rtos (getvar "textsize")))
   (setq SIZE (getstring (strcat "\nText Size <"s">:")))
   (if (= SIZE "") (setq SIZE S))
   (setq ROTA (getstring "\nRotation<0>:"))
   (if (= ROTA "") (setq ROTA "0"))
   (setq Y 0)
   (setq TXT (getstring Y "\nText:"))
   (command "text" JUST P1 SIZE ROTA TXT)
   (setq TXT (getstring Y "\nText:"))
   (command "text" JUST P2 SIZE ROTA TXT)
   (while (/= TXT "")
      (setq P3 (polar P2 (angle P1 P2) DIST))
      (setq TXT (getstring Y "\nText  (quit with <return>):  "))
      (command "text" JUST P3 SIZE ROTA TXT)
      (setq P2 P3)
   )
   (setvar "CMDECHO" 1)
   (princ)
); end txt.lsp

